Attribute VB_Name = "Module1"
Option Explicit
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Public Declare Function INIWRITE Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function INIGET Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Public Declare Function IsWindowVisible& Lib "user32" (ByVal hwnd As Long)
Public Declare Function GetParent& Lib "user32" (ByVal hwnd As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageLong& Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function VirtualAllocEx Lib "kernel32" (ByVal hProcess As Long, ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFreeEx Lib "kernel32" (ByVal hProcess As Long, lpAddress As Any, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
Private Declare Function WriteProcessMemory Lib "kernel32" (ByVal hProcess As Long, lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function RegisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Private Declare Function UnregisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageSTRING Lib "user32" Alias "SendMessageW" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function SendMessageStr Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As String) As Long
Public Declare Function EnableWindow Lib "user32" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Private Const EM_LINELENGTH = &HC1
Private Const GW_CHILD = 5
Private Const GW_HWNDNEXT = 2
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_GETLINE = &HC4
Public Const WM_GETTEXTLENGTH = &HE
Private Type LV_ITEM
    mask As Long
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type
Const WM_COMMAND = &H111
Const WM_SETTEXT = &HC
Private Const LVM_FIRST = &H1000&
Private Const LVM_SETITEMSTATE = (LVM_FIRST + 43)
Private Const LVIF_STATE = &H8&
Private Const LVIS_FOCUSED = &H1
Private Const LVIS_SELECTED = &H2&
Private Const PROCESS_VM_OPERATION = &H8
Private Const PROCESS_VM_READ = &H10
Private Const PROCESS_VM_WRITE = &H20
Private Const PAGE_READWRITE = &H4&
Private Const MEM_RESERVE = &H2000
Private Const MEM_COMMIT = &H1000
Private Const MEM_RELEASE = &H8000
Private hWndlvw As Long
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_GETTEXT = &HD
Private Const HTCAPTION = 2
Dim sPattern As String, hFind As Long
Global stralt As String
Global straltL As String
Global buildstr As String
Private Const WM_HOTKEY = &H312
Public Const VK_SPACE = &H20
Private Const MOD_ALT = &H1
Private Const MOD_CONTROL = &H2
Private Const MOD_SHIFT = &H4
Public Const EM_SETSEL = 177
Public Const EM_GETSEL = 176
Public Const WM_CUT = 768
Public Const WM_PASTE = 770
Private Const GWL_WNDPROC = (-4)
Public Const WM_KEYDOWN = &H100
Public Const WM_KEYUP = &H101
Private lPrevWnd As Long
Private lhWnd As Long
Private lHotKeys As Long

Public Sub SetHotKey(ByVal hwnd As Long, ByVal lID As Long, ByVal lModifier As Long, ByVal lKey As Long)
    'Create a HotKey, if it's the 1st one, Subclass the Form to be able to Capture the HotKeys...
    If lPrevWnd = 0 Then
        'Subclass the Form diverting all message to our "SubWindow()" function
        lhWnd = hwnd
        lPrevWnd = SetWindowLong(lhWnd, GWL_WNDPROC, AddressOf SubWindow)
    End If
    'Register the HotKey with Windows
    Call RegisterHotKey(lhWnd, lID, lModifier, lKey)
    'Keep track of the No. of HotKeys
    lHotKeys = lHotKeys + 1
End Sub

Public Sub RemoveHotKey(ByVal lID As Long)
    'Remove the HotKey, if it was the last one, remove the Form Subclassing
    Call UnregisterHotKey(lhWnd, lID)
    lHotKeys = lHotKeys - 1
    If lHotKeys = 0 Then Call SetWindowLong(lhWnd, GWL_WNDPROC, lPrevWnd)
End Sub

Private Function SubWindow(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    'Check for the HotKey Message and take action depending on which HotKey is pressed
    If Msg = WM_HOTKEY Then
        Select Case wParam
        Case 1
        Call Bouncer
        Call SetForegroundWindow(lhWnd)
        Case 2
        Dim window As Long
Dim X As Long, editx As Long
Dim Button As Long
Dim dlggroupchatwindowclass As Long
On Error Resume Next
dlggroupchatwindowclass = FindWindow("dlggroupchat window class", Form1.Combo1.Text)
PostMessage dlggroupchatwindowclass, WM_COMMAND, 32946, 0
        End Select
    End If
    'Pass on the Message to the Default Window Message Handler
    SubWindow = CallWindowProc(lPrevWnd, hwnd, Msg, wParam, ByVal lParam)
End Function
Sub Delay(ByVal nSeconds As Single)
    Dim nStart As Single
    
    nStart = Timer
    
    Do
        DoEvents
    Loop Until Timer - nStart >= nSeconds
End Sub
Private Function Bouncer()
Dim window As Long
Dim X As Long, editx As Long
Dim Button As Long
Dim dlggroupchatwindowclass As Long
On Error Resume Next
dlggroupchatwindowclass = FindWindow("dlggroupchat window class", Form1.Combo1.Text)
PostMessage dlggroupchatwindowclass, WM_COMMAND, 32947, 0
Shell (App.Path & "\BC.exe")
End Function
Private Function EnumWindowsProc(ByVal hwnd As Long, ByVal lParam As String) As Long
Dim strCaption As String
Dim lLen As Long
Dim dlggroupchatwindowclass As Long, splitterwindowex As Long, classcpanecontainerex As Long
Dim atladf As Long, atladff As Long
dlggroupchatwindowclass = FindWindow("dlggroupchat window class", Form1.Combo1.Text)
splitterwindowex = FindWindowEx(dlggroupchatwindowclass, 0&, "splitterwindowex", vbNullString)
splitterwindowex = FindWindowEx(splitterwindowex, 0&, "splitterwindowex", vbNullString)
splitterwindowex = FindWindowEx(splitterwindowex, 0&, "splitterwindowex", vbNullString)
splitterwindowex = FindWindowEx(splitterwindowex, 0&, "splitterwindowex", vbNullString)
splitterwindowex = FindWindowEx(splitterwindowex, 0&, "splitterwindowex", vbNullString)
splitterwindowex = FindWindowEx(splitterwindowex, 0&, "splitterwindowex", vbNullString)
classcpanecontainerex = FindWindowEx(splitterwindowex, 0&, "classcpanecontainerex", vbNullString)
classcpanecontainerex = FindWindowEx(splitterwindowex, classcpanecontainerex, "classcpanecontainerex", vbNullString)
atladf = GetWindow(classcpanecontainerex, GW_CHILD)
hWndlvw = GetWindow(atladf, GW_CHILD)
hWndlvw = GetWindow(hWndlvw, GW_HWNDNEXT)
'atladf = FindWindowEx(classcpanecontainerex, 0&, "atl:00a37ee8", vbNullString)
'hWndlvw = FindWindowEx(atladf, 0&, "atl:00a37f78", vbNullString)
    ' If we've found a window with the SysListView32 class
    ' check to see if parent window caption is the one we are looking for
    If hWndlvw <> 0 Then
        lLen = GetWindowTextLength(hwnd)
        If lLen > 0 Then
            strCaption = Space(lLen)
            GetWindowText hwnd, strCaption, lLen + 1
        End If
    End If
    EnumWindowsProc = (hWndlvw = 0 And strCaption <> lParam)
End Function

' New example looks for a window with class SysListView32 that is hosted
' by a window whose caption matches the contents of strInWindowWithCaption
Public Function FindListView(strInWindowWithCaption As String) As Long
    EnumWindows AddressOf EnumWindowsProc, StrPtr(strInWindowWithCaption)
    FindListView = hWndlvw
End Function


Public Function MessageCrossProcess(ByVal hwnd As Long)
    Dim lProcID As Long
    Dim hProc As Long
    Dim lxprocLVITEM As Long
    Dim LVITEM As LV_ITEM
    Dim lItemPos As Long
   
    GetWindowThreadProcessId hwnd, lProcID ' Get the process ID in which the ListView is running
    If lProcID <> 0 Then
        hProc = OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ Or PROCESS_VM_WRITE, False, lProcID) ' make sure we have read write permissions in the process space
        If hProc <> 0 Then
            lxprocLVITEM = VirtualAllocEx(hProc, 0, LenB(LVITEM), MEM_RESERVE Or MEM_COMMIT, PAGE_READWRITE) ' Grab enough memory in the other procedure's space to hold our LV_ITEM
           
            ' Set up our local LV_ITEM to change the selected item
            LVITEM.mask = LVIF_STATE
            LVITEM.state = True
            LVITEM.stateMask = LVIS_SELECTED Or LVIS_FOCUSED ' Just enforcing the selection better than in original version by moving the focus as well
            ' Copy the local LV_ITEM into the space we reserved in the foreign process
            WriteProcessMemory hProc, ByVal lxprocLVITEM, ByVal VarPtr(LVITEM), LenB(LVITEM), 0
           
            ' Now send the message, but pass the address of the copy of our LV_ITEM that now exists in the foreign process instead of our local version
            ' Aigh Peeps this wha you need to change in order to higlight the item you want :)
            lItemPos = Form1.Text8.Text ' first item
            SendMessage hwnd, LVM_SETITEMSTATE, lItemPos, ByVal lxprocLVITEM
           
            ' Clean up
            VirtualFreeEx hProc, ByVal lxprocLVITEM, LenB(LVITEM), MEM_RELEASE
            CloseHandle hProc
        End If
    End If
End Function
Private Function getPalSubForm(ByVal TargetWinClass As String, _
    ByVal TargetWinCaption As String, ByVal TargetSubClass As String, _
    ByVal TargetSubClassIndex As Integer) As Long
    'set variables in module
    mTargetWinClass = TargetWinClass
    mTargetWinCaption = TargetWinCaption
    mTargetSubClass = TargetSubClass
    mTargetSubClassIndex = TargetSubClassIndex
    'set variables for EnumWindows function
    Dim lRet As Long
    Dim lParam As Long
    'Enum sub windows to get hnd for target
    lRet = EnumWindows(AddressOf FindSubWinds, lParam)
    'return target hnd
    getPalSubForm = mSubFormHnd
End Function

